function OnEvent_Initialize(MessengerStart)
{

}

function OnGetScriptCommands()
{
    var commands = '<ScriptCommands>';
        commands+='<Command>';
            commands+='<Name>Code.C#</Name>';
            commands+='<Description>Code highlight</Description>';
            commands+='<Parameters>Code</Parameters>';
        commands+='</Command>';
    commands+='</ScriptCommands>';
    return commands;
}

function OnEvent_ChatWndSendMessage(ChatWnd, Message)
{
    var cmd = Message.split(" ");
    if (cmd.length <= 0) return Message;
    
    if (cmd[0] == "/Code.C#")
    {
        Message = Message.substring(Message.indexOf(" ")+1);
    }
    else return Message;
    
    var Dic =
    {
        Classes:
            new Array(
                "Application",
                "Form",
                "Control",
                "Button",
                "CheckBox",
                "ComboBox",
                "ColorDialog",
                "Cursors",
                "Cursor",
                "DataGridView",
                "FileDialog",
                "FontDialog",
                "GroupBox",
                "Label",
                "ListView",
                "MenuStrip",
                "MessageBox",
                "Panel",
                "ProgressBar",
                "RadioButton",
                "RichTextBox",
                "ScrollBar",
                "SendKeys",
                "StatusBar",
                "StatusStrip",
                "TabControl",
                "TabPage",
                "TextBox",
                "Timer",
                "ToolBar",
                "ToolStrip",
                "ToolStripMenuItem",
                "TreeView",
                "UserControl",
                "WebBrowser",
                
                "Bitmap",
                "Brush",
                "Brushes",
                "BufferedGraphics",
                "BufferedGraphicsContext",
                "Color",
                "ColorConverter",
                "Image",
                "Font",
                "FontConverter",
                "FontFamily",
                "FontStyle",
                "Graphics",
                "GraphicsUnit",
                "Icon",
                "IconConverter",
                "Image",
                "ImageAnimator",
                "ImageConverter",
                "ImageFormatConverter",
                "KnownColor",
                "Pen",
                "Pens",
                "Point",
                "PointF",
                "PointConverter",
                "Rectangle",
                "RectangleF",
                "Region",
                "RotateFlipType",
                "Size",
                "SizeF",
                "SizeConverter",
                "SizeFConverter",
                "SolidBrush",
                "StringFormat",
                "TextureBrush",
                
                "EventArgs",
                
                "DateTime",
                
                "List",
                "Array",
                "ArrayList",
                "Hashtable",
                
                "Stream",
                "StreamReader",
                "StreamWriter",
                "File",
                "FileInfo",
                "TextReader",
                "TextWriter",
                "Directory"
            ),
        
        Words:
            new Array(
                "abstract",
                "event",
                "new",
                "struct",
                "as",
                "explicit",
                "null",
                "switch",
                "base",
                "extern",
                "object",
                "this",
                "bool",
                "false",
                "operator",
                "throw",
                "break",
                "finally",
                "out",
                "true",
                "byte",
                "fixed",
                "override",
                "try",
                "case",
                "float",
                "params",
                "typeof",
                "catch",
                "for",
                "private",
                "uint",
                "char",
                "foreach",
                "protected",
                "ulong",
                "checked",
                "goto",
                "public",
                "unchecked",
                "class",
                "if",
                "readonly",
                "unsafe",
                "const",
                "implicit",
                "ref",
                "ushort",
                "continue",
                "in",
                "return",
                "using",
                "decimal",
                "int",
                "sbyte",
                "virtual",
                "default",
                "interface",
                "sealed",
                "volatile",
                "delegate",
                "internal",
                "short",
                "void",
                "do",
                "is",
                "sizeof",
                "while",
                "double",
                "lock",
                "stackalloc",
                 
                "else",
                "long",
                "static",
                 
                "enum",
                "namespace",
                "string"
            )
    };
    var reg;
    reg = Dic.Classes.join("\\b|\\b");
    reg = "(\\b" + reg + "\\b)";
    Message = Message.replace(new RegExp(reg, "mg"), "[c=10]$1[/c]");
    
    reg = Dic.Words.join("\\b|\\b");
    reg = "(\\b" + reg + "\\b)";
    Message = Message.replace(new RegExp(reg, "mg"), "[c=48]$1[/c]");
    
    // Comment
    Message = Message.replace(/(\/\/[^\r]+)/mg, "[c=3]$1[/c]");
    
    /// Comment
    Message = Message.replace(/(\/\/\/[^\r]+)/mg, "[c=14]$1[/c]");
    
    /* Comment */
    //Message = Message.replace(/(\/\*([^\*])*?\*\/)/g, "[c=3]$1[/c]");
    
    // Strings in Quotes ""
    Message = Message.replace(/(\".*?\")/g, "[c=5]$1[/c]");
    
    return Message;
}

function OnEvent_Uninitialize(MessengerExit)
{
}
